Index: lib/spatial/mapbuilder/lib/widget/AoiForm.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/AoiForm.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/AoiForm.js	(revision 4307)
@@ -2,18 +2,17 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: AoiForm.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
 mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
-mapbuilder.loadScript(baseDir+"/model/Proj.js");
 
 /**
  * Widget to display the AOI box coordinates in a form.
  *
  * @constructor
- * @base WidgetBase
+ * @base WidgetBaseXSL
  * @param widgetNode This widget's object node from the configuration document.
  * @param model The model that this widget is a view of.
  */
@@ -28,13 +27,13 @@
    * @param targetNode The node for the enclosing HTML tag for this widget.
    */
   this.displayAoiCoords = function(objRef, targetNode) {
-    objRef.aoiForm = document.getElementById(objRef.formName);
+    var aoiForm = document.getElementById(objRef.formName);
     var aoi = objRef.model.getParam("aoi");
-    if (aoi && objRef.aoiForm) {
-      objRef.aoiForm.westCoord.value = aoi[0][0];
-      objRef.aoiForm.northCoord.value = aoi[0][1];
-      objRef.aoiForm.eastCoord.value = aoi[1][0];
-      objRef.aoiForm.southCoord.value = aoi[1][1];
+    if (aoi && aoiForm) {
+      aoiForm.westCoord.value = aoi[0][0];
+      aoiForm.northCoord.value = aoi[0][1];
+      aoiForm.eastCoord.value = aoi[1][0];
+      aoiForm.southCoord.value = aoi[1][1];
     }
   }
   this.model.addListener('aoi', this.displayAoiCoords, this);
@@ -71,25 +70,20 @@
    * @param objRef Pointer to this AoiForm object.
    */
   this.postPaint = function(objRef) {
-    objRef.aoiForm = document.getElementById(objRef.formName);
-    objRef.aoiForm.westCoord.onblur = objRef.setAoi;
-    objRef.aoiForm.northCoord.onblur = objRef.setAoi;
-    objRef.aoiForm.eastCoord.onblur = objRef.setAoi;
-    objRef.aoiForm.southCoord.onblur = objRef.setAoi;
-    objRef.aoiForm.westCoord.model = objRef.model;
-    objRef.aoiForm.northCoord.model = objRef.model;
-    objRef.aoiForm.eastCoord.model = objRef.model;
-    objRef.aoiForm.southCoord.model = objRef.model;
+    var aoiForm = document.getElementById(objRef.formName);
+    aoiForm.westCoord.onblur = objRef.setAoi;
+    aoiForm.northCoord.onblur = objRef.setAoi;
+    aoiForm.eastCoord.onblur = objRef.setAoi;
+    aoiForm.southCoord.onblur = objRef.setAoi;
+    aoiForm.westCoord.model = objRef.model;
+    aoiForm.northCoord.model = objRef.model;
+    aoiForm.eastCoord.model = objRef.model;
+    aoiForm.southCoord.model = objRef.model;
   }
 
   //set some properties for the form output
   //allow it to have a different form name
-  var formNameNode = widgetNode.selectSingleNode("mb:formName");
-  if ( formNameNode ) {
-    this.formName = formNameNode.firstChild.nodeValue;
-  } else {
-    this.formName = "AoiForm_" + mbIds.getId();
-  }
+  this.formName = this.getProperty("mb:formName", "AoiForm_" + mbIds.getId());
   this.stylesheet.setParameter("formName", this.formName);
 }
 
Index: lib/spatial/mapbuilder/lib/widget/MapTitle.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/MapTitle.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/MapTitle.xsl	(revision 4307)
@@ -1,36 +1,2 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsl:stylesheet version="1.0"
-xmlns:wmc="http://www.opengis.net/context"
-xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-
-<!--
-Description: Displays the Title value from a Web Map Context document
-Author:      Cameron Shorter cameron ATshorter.net
-Licence:     LGPL as per: http://www.gnu.org/copyleft/lesser.html
-
-$Id$
-$Name$
--->
-
-  <xsl:output method="xml" encoding="utf-8"/>
-
-  <xsl:param name="lang">en</xsl:param>
-
-  <!-- Main html -->
-  <xsl:template match="/wmc:ViewContext/wmc:General | /wmc:OWSContext/wmc:General ">
-    <span>
-      <xsl:choose>
-        <xsl:when test="wmc:Title/@xml:lang">              
-          <xsl:value-of select="wmc:Title[@xml:lang=$lang]"/>
-        </xsl:when>
-        <xsl:otherwise>
-          <xsl:value-of select="wmc:Title"/>
-        </xsl:otherwise>
-      </xsl:choose>
-    </span>
-  </xsl:template>
-  
-  <xsl:template match="text()|@*"/>
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:wmc="http://www.opengis.net/context" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" encoding="utf-8" omit-xml-declaration="yes"/><xsl:param name="lang">en</xsl:param><xsl:template match="/wmc:ViewContext/wmc:General | /wmc:OWSContext/wmc:General "><span><xsl:choose><xsl:when test="wmc:Title/@xml:lang"><xsl:value-of select="wmc:Title[@xml:lang=$lang]"/></xsl:when><xsl:otherwise><xsl:value-of select="wmc:Title"/></xsl:otherwise></xsl:choose></span></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/FilterAttributes.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/FilterAttributes.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/FilterAttributes.xsl	(revision 4307)
@@ -1,70 +1,3 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-<!--
-Description: parse DescribeFeatureType response to provide filter params
-Author:      adair
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-$Id$
-$Name$
--->
-
-<xsl:stylesheet version="1.0" 
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
-		xmlns:gml="http://www.opengis.net/gml">
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-  <!-- The coordinates of the DHTML Layer on the HTML page -->
-  <xsl:param name="modelId"/>
-  <xsl:param name="widgetId"/>
-  
-  <xsl:param name="elementName">
-    <xsl:value-of select="/xsd:schema/xsd:element/@name"/>
-  </xsl:param>
-  <xsl:param name="elementType">
-    <xsl:value-of select="/xsd:schema/xsd:element/@type"/>
-  </xsl:param>
-  <xsl:param name="elementTypeNoNs">
-    <xsl:value-of select="substring-after($elementType,':')"/>
-  </xsl:param>
-  
-  <!-- template rule matching source root element -->
-  <xsl:template match="/xsd:schema">
-    <table>
-      <tr>
-        <th colspan="3">
-          Attributes for: <xsl:value-of select="$elementName"/> of type:<xsl:value-of select="$elementType"/>
-        </th>
-      </tr>
-      <xsl:apply-templates select="xsd:complexType[@name=$elementTypeNoNs]"/>
-    </table>
-  </xsl:template>
-
-  <!--
-<xsd:complexType name="Landuse__Lat_Lon__Type">
-<xsd:complexContent>
-<xsd:extension base="gml:AbstractFeatureType">
-<xsd:sequence>
-<xsd:element name="GML_Geometry" -->
-
-  <!-- template rule matching source root element -->
-  <xsl:template match="xsd:element">
-    <xsl:variable name="name"><xsl:value-of select="@name"/></xsl:variable>
-    <xsl:variable name="type"><xsl:value-of select="@type"/></xsl:variable>
-    <tr>
-      <td>
-        <xsl:value-of select="$name"/>
-      </td>
-      <td>
-        <xsl:value-of select="$type"/>
-      </td>
-      <td>
-      </td>
-    </tr>
-  </xsl:template>
-
-  <!--xsl:template match="text()|@*"/-->
-
-</xsl:stylesheet>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:gml="http://www.opengis.net/gml" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:param name="elementName"><xsl:value-of select="/xsd:schema/xsd:element/@name"/></xsl:param><xsl:param name="elementType"><xsl:value-of select="/xsd:schema/xsd:element/@type"/></xsl:param><xsl:param name="elementTypeNoNs"><xsl:value-of select="substring-after($elementType,':')"/></xsl:param><xsl:template match="/xsd:schema"><table><tr><th colspan="3">
+          Attributes for: <xsl:value-of select="$elementName"/> of type:<xsl:value-of select="$elementType"/></th></tr><xsl:apply-templates select="xsd:complexType[@name=$elementTypeNoNs]"/></table></xsl:template><xsl:template match="xsd:element"><xsl:variable name="name"><xsl:value-of select="@name"/></xsl:variable><xsl:variable name="type"><xsl:value-of select="@type"/></xsl:variable><tr><td><xsl:value-of select="$name"/></td><td><xsl:value-of select="$type"/></td><td/></tr></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/PanZoomBar.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/PanZoomBar.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/PanZoomBar.js	(revision 4307)
@@ -0,0 +1,31 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id$
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBase.js");
+
+/**
+ * PanZoomBar  - drag, zoom, zoomBar wheelMouse and keyboard events 
+ * @constructor
+ * @base WidgetBase
+ * @author Olivier Terral olivier.terralAtgeomatys.fr
+ * @param widgetNode The widget node from the Config XML file.
+ * @param model The model for this widget
+ */
+function PanZoomBar(widgetNode, model) {
+  // Extend ButtonBase
+  WidgetBase.apply(this, new Array(widgetNode, model));
+
+  this.cursor = 'crosshair';
+
+  this.init = function(objRef) {
+   objRef.model.map.addControl(new OpenLayers.Control.PanZoomBar());
+   objRef.model.map.addControl(new OpenLayers.Control.Navigation());
+   objRef.model.map.addControl(new OpenLayers.Control.KeyboardDefaults());
+  }
+  
+  this.model.addListener("refresh",this.init, this); 
+}
+
Index: lib/spatial/mapbuilder/lib/widget/InsertFeature.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/InsertFeature.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/InsertFeature.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: InsertFeature.js 3879 2008-02-27 14:20:29Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -23,12 +23,12 @@
   // Extend ButtonBase
   ButtonBase.apply(this, new Array(widgetNode, model));
 
-  this.trm=widgetNode.selectSingleNode("mb:transactionResponseModel").firstChild.nodeValue;
-  this.tm=widgetNode.selectSingleNode("mb:targetModel").firstChild.nodeValue;
-  this.tc=widgetNode.selectSingleNode("mb:targetContext").firstChild.nodeValue;
+  this.trm=this.getProperty("mb:transactionResponseModel");
+  this.tm=this.getProperty("mb:targetModel");
+  this.tc=this.getProperty("mb:targetContext");
 
   this.httpPayload=new Object();
-  this.httpPayload.url=widgetNode.selectSingleNode("mb:webServiceUrl").firstChild.nodeValue;
+  this.httpPayload.url=this.getProperty("mb:webServiceUrl");
   this.httpPayload.method="post";
 
   /** Xsl to convert Feature into a WFS Transaction Insert. */
@@ -37,22 +37,31 @@
   /** Xsl to convert Feature into a WFS Transaction Update. */
   this.updateXsl=new XslProcessor(baseDir+"/tool/xsl/wfs_Update.xsl");
 
+  /** creates the OL control for this button */
+  this.createControl = function(objRef) {
+    var Control = OpenLayers.Class(OpenLayers.Control, {
+      CLASS_NAME: 'mbInsertFeature',
+      type: OpenLayers.Control.TYPE_BUTTON
+    });
+    return Control;
+  }
+
   /**
    * Start a WFS-T InsertFeature transaction.
    * @param objRef Pointer to this object.
    */
-  this.doSelect = function(selected,objRef) {
+  this.doSelect = function(objRef, selected) {
     if (selected){
       // Model that will be populated with the WFS response.
       if (!objRef.transactionResponseModel){
-        objRef.transactionResponseModel=eval("config.objects."+objRef.trm);
+        objRef.transactionResponseModel=window.config.objects[objRef.trm];
         objRef.transactionResponseModel.addListener("loadModel",objRef.handleResponse, objRef);
       }
       if (!objRef.targetModel){
-        objRef.targetModel=eval("config.objects."+objRef.tm);
+        objRef.targetModel=window.config.objects[objRef.tm];
       }
       if (!objRef.targetContext){
-        objRef.targetContext=eval("config.objects."+objRef.tc);
+        objRef.targetContext=window.config.objects[objRef.tc];
       }
       fid=objRef.targetModel.getXpathValue(objRef.targetModel,"//@fid");
       if (objRef.targetModel.doc){
@@ -64,8 +73,9 @@
           s=objRef.insertXsl.transformNodeToObject(objRef.targetModel.doc);
         }
         objRef.httpPayload.postData=s;
+        objRef.transactionResponseModel.transactionType="insert";
         objRef.transactionResponseModel.newRequest(objRef.transactionResponseModel,objRef.httpPayload);
-      }else alert("No feature available to insert");
+      }else alert(mbGetMessage("noFeatureToInsert"));
     }
   }
 
@@ -76,14 +86,15 @@
    * @param objRef Pointer to this object.
    */
   this.handleResponse=function(objRef){
-    sucess=objRef.transactionResponseModel.doc.selectSingleNode("//wfs:TransactionResult/wfs:Status/wfs:SUCCESS");
-    if (sucess){
-      // Remove FeatureList
-      objRef.targetModel.setModel(objRef.targetModel,null);
+    if (objRef.transactionResponseModel.transactionType=="insert") {
+      success=objRef.transactionResponseModel.doc.selectSingleNode("//wfs:TransactionResult/wfs:Status/wfs:SUCCESS");
+      if (success){
+        // Remove FeatureList
+        config.loadModel(objRef.targetModel.id, objRef.targetModel.url);
 
-      // Repaint the WMS layers
-      objRef.targetContext.callListeners("refreshWmsLayers");
+        // Repaint the WMS layers
+        objRef.targetContext.callListeners("refreshWmsLayers");
+      }
     }
   }
-
 }
Index: lib/spatial/mapbuilder/lib/widget/TipWidgetOL.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/TipWidgetOL.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/TipWidgetOL.js	(revision 4307)
@@ -0,0 +1,157 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: TipWidgetOL.js 3955 2008-03-31 13:00:49Z ahocevar $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/TipWidgetBase.js");
+mapbuilder.loadScript(baseDir+"/util/openlayers/OpenLayers.js");
+
+/**
+ * Manages MapTips on the map. This widget works with models that
+ * have a FeatureSelectHandler tool.
+ * @base TipWidgetBase
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @param widgetNode      The tool node from the Config XML file.
+ * @param model  The ButtonBar widget.
+ */
+function TipWidgetOL(widgetNode, model) {
+  TipWidgetBase.apply(this, new Array(widgetNode, model));
+
+  /**
+   * This method is triggered when a user clicks on a feature.
+   * @param objRef reference to this widget
+   */
+  this.onClick = function(objRef) {
+    var evt = objRef.model.getParam("olFeatureSelect");
+    var popup = objRef.createPopup(objRef, evt, false);
+    evt.feature.layer.mbClickPopup = popup;
+  }
+
+  /**
+   * This method is triggered when the mouse is over a feature.
+   * @param objRef reference to this widget
+   */
+  this.onMouseover = function(objRef) {
+    var evt = objRef.model.getParam("olFeatureHover");
+    // only create popup if there is no visible click popup
+    if (evt.feature && !evt.feature.layer.mbClickPopup || !evt.feature.layer.mbClickPopup.visible()) {
+      var popup = objRef.createPopup(objRef, evt, true);
+      evt.feature.layer.mbHoverPopup = popup;
+      // if the olFeatureOut event gets lost (eg during drag operation),
+      // registering this additional event will help to get rid of the
+      // popup quickly
+      popup.events.register('mouseover', popup, popup.hide);
+    }
+  }
+  
+  /**
+   * This method is triggered when the mouse moves out of a feature.
+   * @param objRef reference to this widget
+   */
+  this.onMouseout = function(objRef) {
+    var feature = objRef.model.getParam("olFeatureOut");
+    if (feature && feature.layer && feature.layer.mbHoverPopup) {
+      feature.layer.mbHoverPopup.destroy();
+      feature.layer.mbHoverPopup = null;
+    }
+  }
+
+  /**
+   * Creates a popup.
+   * @param objRef reference to this widget
+   * @param evt OpenLayers.Event that triggered the popup action
+   * @param hover true if the popup should be styled as a hover popup,
+   * false if it is a click popup.
+   * @return reference to the created popup
+   */
+  this.createPopup = function(objRef, evt, hover) {
+    var feature = evt.feature;
+    // check if there is a source model linked with this feature
+    var sourceNode = objRef.model.doc.selectSingleNode("//*[@fid='"+feature.fid+"']");
+    var sourceModel = null;
+    if (sourceNode) {
+      sourceModel = sourceNode.getAttribute('sourceModel');
+    }
+    // if so, use the config from the source model
+    var widgetConfig = null;
+    if (sourceModel && config.objects[sourceModel].config && config.objects[sourceModel].config[objRef.id]) {
+      widgetConfig = config.objects[sourceModel].config[objRef.id];
+    } else {
+      widgetConfig = objRef.config;
+    }
+    widgetConfig.stylesheet.setParameter('fid', feature.fid);
+    var lonlat = feature.layer.map.getLonLatFromPixel(evt.xy);
+    var popup = new Mapbuilder.Popup(null, lonlat, new OpenLayers.Size(widgetConfig.width, widgetConfig.height),
+        new XMLSerializer().serializeToString(widgetConfig.stylesheet.transformNodeToObject(widgetConfig.model.doc)).replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&amp;/g,"&"),
+        null, hover == false);
+    popup.setOpacity(widgetConfig.opacity);
+    popup.setBackgroundColor(widgetConfig.backgroundColor);
+    popup.setBorder(widgetConfig.border);
+    var quadrant = feature.layer.map.getExtent().determineQuadrant(lonlat);
+    var lonOffset = quadrant.charAt(1) == 'r' ? -5 : 5;
+    var latOffset = quadrant.charAt(0) == 't' ? 5 : -5;
+    popup.anchor = { size: new OpenLayers.Size(0,0), offset: new OpenLayers.Pixel(lonOffset, latOffset)};    
+ 
+    feature.layer.map.addPopup(popup, true);
+    return popup;
+  }
+  
+}
+
+/**
+ * Derived from OpenLayers.Popup (svn r6430) and 
+ * OpenLayers.Popup.Anchored (svn r5614), this class preserves the
+ * functionality of OpenLayers.Popup.Anchored before the new style popups
+ * of http://trac.openlayers.org/ticket/926 were introduced.
+ */
+Mapbuilder.Popup = OpenLayers.Class(OpenLayers.Popup.Anchored, {
+
+  initialize: function(id, lonlat, size, contentHTML, anchor, closeBox,
+            closeBoxCallback) {
+    OpenLayers.Popup.Anchored.prototype.initialize.apply(this, arguments);
+    this.contentDiv.style.overflow = "hidden";
+  },
+  
+  setSize:function(size) { 
+    if (size != undefined) {
+      this.size = size; 
+    }
+    
+    if (this.div != null) {
+      this.div.style.width = this.size.w + "px";
+      this.div.style.height = this.size.h + "px";
+    }
+    if (this.contentDiv != null){
+      this.contentDiv.style.width = this.size.w + "px";
+      this.contentDiv.style.height = this.size.h + "px";
+    }
+
+    if ((this.lonlat) && (this.map)) {
+      var px = this.map.getLayerPxFromLonLat(this.lonlat);
+      this.moveTo(px);
+    }
+  },  
+  
+  addCloseBox:function(closeBoxCallback) {
+     // close icon
+    var closeSize = new OpenLayers.Size(17,17);
+    var img = config.skinDir + "/openlayers/img/close.gif";
+    this.closeDiv = OpenLayers.Util.createAlphaImageDiv(
+      this.id + "_close", null, closeSize, img
+    );
+    this.closeDiv.style.right = this.padding + "px";
+    this.closeDiv.style.top = this.padding + "px";
+    this.groupDiv.appendChild(this.closeDiv);
+
+    var closePopup = closeBoxCallback || function(e) {
+      this.hide();
+      OpenLayers.Event.stop(e);
+    };
+    OpenLayers.Event.observe(this.closeDiv, "click", 
+        OpenLayers.Function.bindAsEventListener(closePopup, this));
+  },
+  
+  CLASS_NAME: "Mapbuilder.Popup"
+});
+
Index: lib/spatial/mapbuilder/lib/widget/SelectMapLayers.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectMapLayers.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/SelectMapLayers.js	(revision 4307)
@@ -0,0 +1,18 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: SelectMapLayers.js 2546 2007-01-23 12:07:39Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/widget/WidgetBaseXSL.js");
+
+/**
+ * Presents the list of Layers from a WMS capabilities doc.
+ * @constructor
+ * @base WidgetBaseXSL
+ * @param widgetNode  The widget's XML object node from the configuration document.
+ * @param model       The model object that this widget belongs to.
+ */
+function SelectMapLayers(widgetNode, model) {
+  WidgetBaseXSL.apply(this,new Array(widgetNode, model));
+}
Index: lib/spatial/mapbuilder/lib/widget/SelectTimeFrame.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/SelectTimeFrame.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/SelectTimeFrame.js	(revision 4307)
@@ -2,7 +2,7 @@
 Author:       Mike Adair mike.adairATccrs.nrcan.gc.ca
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: SelectTimeFrame.js 2511 2007-01-05 11:55:23Z gjvoosten $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -38,7 +38,7 @@
     if (index > timestampList.firstFrame) {
       timestampList.lastFrame = index;
     } else {
-      alert("last frame must be after the first frame");
+      alert(mbGetMessage("lastFrameAfterFirst"));
     }
     this.model.setParam("stopLoop");
   }
Index: lib/spatial/mapbuilder/lib/widget/ShowDistance.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/widget/ShowDistance.xsl	(nonexistent)
+++ lib/spatial/mapbuilder/lib/widget/ShowDistance.xsl	(revision 4307)
@@ -0,0 +1,2 @@
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes"/><xsl:param name="modelId"/><xsl:param name="widgetId"/><xsl:param name="action"/><xsl:param name="skinDir" select="/mb:MapbuilderConfig/mb:skinDir"/><xsl:param name="distance">Distance:</xsl:param><xsl:param name="formName"/><xsl:template match="/"><div><form name="{$formName}" id="{$formName}"><xsl:value-of select="$distance"/><input name="distance" type="text" size="8" readonly="readonly"/></form></div></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/widget/WidgetBaseXSL.js
===================================================================
--- lib/spatial/mapbuilder/lib/widget/WidgetBaseXSL.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/widget/WidgetBaseXSL.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: WidgetBaseXSL.js 3892 2008-02-29 18:21:12Z ahocevar $
 */
 
 mapbuilder.loadScript(baseDir+"/widget/WidgetBase.js");
@@ -17,6 +17,7 @@
  * All stylesheets will have "modelId" and "widgetId" parameters set when called.
  *
  * @constructor
+ * @base WidgetBase
  * @author Mike Adair 
  * @param widget      Pointer to the widget instance being created
  * @param widgetNode  The widget's XML object node from the configuration document.
@@ -29,31 +30,27 @@
   // Set this.stylesheet
   // Defaults to "widget/<widgetName>.xsl" if not defined in config file.
   if ( !this.stylesheet ) {
-    var styleNode = widgetNode.selectSingleNode("mb:stylesheet");
-    if (styleNode ) {
-      this.stylesheet = new XslProcessor(styleNode.firstChild.nodeValue,model.namespace);
-    } else {
-      this.stylesheet = new XslProcessor(baseDir+"/widget/"+widgetNode.nodeName+".xsl",model.namespace);
-    }
+    this.stylesheet = new XslProcessor(this.getProperty("mb:stylesheet", baseDir+"/widget/"+widgetNode.nodeName+".xsl", model.namespace));
   }
 
+  // Do we allow to parse HTML nodes?
+  this.parseHTMLNodes = Mapbuilder.parseBoolean(this.getProperty("mb:parseHTMLNodes", false));
+
   // Set widget text values as parameters 
   if (config.widgetText) {
     var textNodeXpath = "/mb:WidgetText/mb:widgets/mb:" + widgetNode.nodeName;
     var textParams = config.widgetText.selectNodes(textNodeXpath+"/*");
     for (var j=0;j<textParams.length;j++) {
-      this.stylesheet.setParameter(textParams[j].nodeName,textParams[j].firstChild.nodeValue);
+      this.stylesheet.setParameter(textParams[j].nodeName,getNodeValue(textParams[j]));
     }
   }
 
   // Set stylesheet parameters for all the child nodes from the config file
   for (var j=0;j<widgetNode.childNodes.length;j++) {
-    if (widgetNode.childNodes[j].firstChild
-      && widgetNode.childNodes[j].firstChild.nodeValue)
+    if (widgetNode.childNodes[j].firstChild)
     {
       this.stylesheet.setParameter(
-        widgetNode.childNodes[j].nodeName,
-        widgetNode.childNodes[j].firstChild.nodeValue);
+        widgetNode.childNodes[j].nodeName, widgetNode.childNodes[j].firstChild.nodeValue);
     }
   }
 
@@ -68,19 +65,23 @@
    * Render the widget.
    * @param objRef Pointer to widget object.
    */
-  this.paint = function(objRef, refresh) {
+  this.paint = function(objRef, refreshId) {
 
-    if (objRef.model.doc && objRef.node && (objRef.autoRefresh||refresh) ) {
+    //pass in a widget ID to refresh only that widget
+    if (refreshId && (refreshId!=objRef.id)) return;
+
+    if (objRef.model.doc && objRef.getNode()) {
       objRef.stylesheet.setParameter("modelUrl", objRef.model.url);
       objRef.stylesheet.setParameter("targetModelId", objRef.targetModel.id );
 
-      //if (objRef.debug) alert("source:"+Sarissa.serialize(objRef.model.doc));
+      //if (objRef.debug) mbDebugMessage(objRef, "source:"+(new XMLSerializer()).serializeToString(objRef.model.doc));
       objRef.resultDoc = objRef.model.doc; // resultDoc sometimes modified by prePaint()
+      objRef.model.setParam("prePaint", objRef);
       objRef.prePaint(objRef);
 
       //confirm inputs
-      if (objRef.debug) alert("prepaint:"+Sarissa.serialize(objRef.resultDoc));
-      if (objRef.debug) alert("stylesheet:"+Sarissa.serialize(objRef.stylesheet.xslDom));
+      if (objRef.debug) mbDebugMessage(objRef, "prepaint:"+(new XMLSerializer()).serializeToString(objRef.resultDoc));
+      if (objRef.debug) mbDebugMessage(objRef, "stylesheet:"+(new XMLSerializer()).serializeToString(objRef.stylesheet.xslDom));
 
       //set to output to a temporary node
       //hack to get by doc parsing problem in IE
@@ -91,33 +92,24 @@
       //process the doc with the stylesheet
       var s = objRef.stylesheet.transformNodeToString(objRef.resultDoc);
       if (config.serializeUrl && objRef.debug) postLoad(config.serializeUrl, s);
-      if (objRef.debug) alert("painting:"+objRef.id+":"+s);
-      tempNode.innerHTML = s;
+      if (objRef.debug) mbDebugMessage(objRef, "painting:"+objRef.id+":"+s);
+      tempNode.innerHTML = objRef.parseHTMLNodes ? Sarissa.unescape(s) : s;
       if( tempNode.firstChild != null ) { //Could be null!
         tempNode.firstChild.setAttribute("id", objRef.outputNodeId);
 
-	    //look for this widgets output and replace if found,
-	    //otherwise append it
-	    if (outputNode) {
-	      objRef.node.replaceChild(tempNode.firstChild,outputNode);
-	    } else {
-	      objRef.node.appendChild(tempNode.firstChild);
-	    }
+  	    //look for this widgets output and replace if found,
+  	    //otherwise append it
+  	    if (outputNode) {
+  	      objRef.getNode().replaceChild(tempNode.firstChild,outputNode);
+  	    } else {
+  	      objRef.getNode().appendChild(tempNode.firstChild);
+  	    }
       }
       objRef.postPaint(objRef);
+      objRef.model.setParam("postPaint", objRef);
     }
   }
   // Call paint when model changes
   this.model.addListener("refresh",this.paint, this);
 
-  /**
-   * Remove widget from display.
-   * @param objRef Pointer to this object.
-   */ 
-  this.clearWidget = function(objRef) {
-    //with objRef.node remove child
-    var outputNode = document.getElementById( objRef.outputNodeId );
-    if (outputNode) objRef.node.removeChild(outputNode);
-  }
-  this.model.addListener("newModel",this.clearWidget, this);
 }
